use std::{ffi::{c_char, CStr}, path::PathBuf};


#[repr(C)]
pub struct ContextRaw {
    pub config_dir: *const c_char
}

#[derive(Debug, Clone)]
pub struct Context {
    pub config_dir: PathBuf
}

impl Context {
    pub fn new(cr: *const ContextRaw) -> Self {
        let config_dir = unsafe {
            let v = CStr::from_ptr((*cr).config_dir);
            PathBuf::from(v.to_string_lossy().to_string())
        };

        Self {
            config_dir
        }
    }
}
